﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Web.Configuration;
using System.Web.Services;
using System.Web.Script.Services;

namespace TreeGridSample
{
    public class TaskData
    {
        private int _TaskId;
        public int TaskId
        {
            get { return _TaskId; }
            set { _TaskId = value; }
        }

        private string _TaskName;
        public string TaskName
        {
            get { return _TaskName; }
            set { _TaskName = value; }
        }

        private string _StartDate;
        public string StartDate
        {
            get { return _StartDate; }
            set { _StartDate = value; }
        }

        private string _EndDate;
        public string EndDate
        {
            get { return _EndDate; }
            set { _EndDate = value; }
        }

        private string _Progress = "";
        public string Progress
        {
            get { return _Progress; }
            set { _Progress = value; }
        }
        private int _Duration;
        public int Duration
        {
            get { return _Duration; }
            set { _Duration = value; }
        }
        private int _ParentId;
        public int ParentId
        {
            get { return _ParentId; }
            set { _ParentId = value; }
        }

    }
    
    public partial class TreeGridSample : System.Web.UI.Page
    {
        string connectionString;
        protected void Page_Load(object sender, EventArgs e)
        {

        }


        public void Update(TaskData Task)
        {
            //Update Edited TaskDetails
            //Using UPDATE SQL Query to Save the Modified taskData into the Table

            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDatabase2008.mdf;Integrated Security=True;Connect Timeout=30");

            int IDNumber = Task.TaskId;

            string cmdString = "UPDATE GanttData SET TaskId=@TaskId, TaskName=@TaskName,StartDate=@StartDate,EndDate=@EndDate,Duration=@Duration,Progress=@Progress,ParentId=@ParentId WHERE TaskId = '" + IDNumber + "'";

            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["SelfReferenceConnectionString"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);
                if (Task.ParentId == null)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }

                sqlCommand.ExecuteNonQuery();
            }

            con.Close();
        }


        public void Add(TaskData Task)
        {

            //Here Task is the added New Task
            //Add Task 
            //Using INSERT Query to add the New Record to SQL Table

            string cmdString = "INSERT INTO GanttData ([TaskName],[TaskId],[StartDate],[EndDate],[Duration],[Progress],[ParentId])" + "VALUES(@TaskName,@TaskId,@StartDate,@EndDate,@Duration,@Progress,@ParentId)";

            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDatabase2008.mdf;Integrated Security=True;Connect Timeout=30");

            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["SelfReferenceConnectionString"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);
                if (Task.ParentId == null)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }

                int test = sqlCommand.ExecuteNonQuery();
            }

            con.Close();

        }
        public void Delete(TaskData Task)
        {

             //Delete Task 
            //Using Delete Query to delete Record from SQL Table

            
            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDatabase2008.mdf;Integrated Security=True;Connect Timeout=30");

            int IDNumber = Task.TaskId;
            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["SelfReferenceConnectionString"].ConnectionString);//connectionString
            con.Open();
            SqlCommand cmd = new SqlCommand("delete from GanttData where TaskId = '" + IDNumber + "'", con);
            int result = cmd.ExecuteNonQuery();
            con.Close();

        }

       
       [WebMethod]
       public static void AddIt(TaskData record)
       {
           TreeGridSample sample = new TreeGridSample();
           sample.Add(record);
         
       }
       [WebMethod]
       public static void UpdateIt(TaskData record)
       {
           TreeGridSample sample1 = new TreeGridSample();
           sample1.Update(record);

       }
       [WebMethod]
       public static void DeleteIt(TaskData record)
       {
           TreeGridSample sample2 = new TreeGridSample();
           sample2.Delete(record);

       }

    }
}